Fix -Wshadow warnings.
[flac.git] / test / test_bins.sh
blob65ba6e20e97f2519374ae7336f904b5e57caca89
1 #!/bin/sh
3 # FLAC - Free Lossless Audio Codec
4 # Copyright (C) 2001,2002,2003,2004,2005,2006,2007,2008,2009 Josh Coalson
6 # This file is part the FLAC project. FLAC is comprised of several
7 # components distributed under difference licenses. The codec libraries
8 # are distributed under Xiph.Org's BSD-like license (see the file
9 # COPYING.Xiph in this distribution). All other programs, libraries, and
10 # plugins are distributed under the GPL (see COPYING.GPL). The documentation
11 # is distributed under the Gnu FDL (see COPYING.FDL). Each file in the
12 # FLAC distribution contains at the top the terms under which it may be
13 # distributed.
15 # Since this particular file is relevant to all components of FLAC,
16 # it may be distributed under the Xiph.Org license, which is the least
17 # restrictive of those mentioned above. See the file COPYING.Xiph in this
18 # distribution.
20 die ()
22 echo $* 1>&2
23 exit 1
26 if [ x = x"$1" ] ; then
27 BUILD=debug
28 else
29 BUILD="$1"
32 LD_LIBRARY_PATH=../src/libFLAC/.libs:$LD_LIBRARY_PATH
33 LD_LIBRARY_PATH=../src/share/grabbag/.libs:$LD_LIBRARY_PATH
34 LD_LIBRARY_PATH=../src/share/getopt/.libs:$LD_LIBRARY_PATH
35 LD_LIBRARY_PATH=../src/share/replaygain_analysis/.libs:$LD_LIBRARY_PATH
36 LD_LIBRARY_PATH=../src/share/replaygain_synthesis/.libs:$LD_LIBRARY_PATH
37 LD_LIBRARY_PATH=../src/share/utf8/.libs:$LD_LIBRARY_PATH
38 LD_LIBRARY_PATH=../objs/$BUILD/lib:$LD_LIBRARY_PATH
39 export LD_LIBRARY_PATH
40 export MALLOC_CHECK_=3
41 export MALLOC_PERTURB_==$(($RANDOM % 255 + 1))
42 PATH=../src/flac:$PATH
43 PATH=../objs/$BUILD/bin:$PATH
44 BINS_PATH=../../test_files/bins
46 if [ x"$FLAC__TEST_LEVEL" = x ] ; then
47 FLAC__TEST_LEVEL=1
50 flac --help 1>/dev/null 2>/dev/null || die "ERROR can't find flac executable"
52 run_flac ()
54 if [ x"$FLAC__TEST_WITH_VALGRIND" = xyes ] ; then
55 echo "valgrind --leak-check=yes --show-reachable=yes --num-callers=100 flac $*" >>test_bins.valgrind.log
56 valgrind --leak-check=yes --show-reachable=yes --num-callers=100 --log-fd=4 flac $* 4>>test_bins.valgrind.log
57 else
58 flac $*
62 test -d ${BINS_PATH} || exit 77
64 test_file ()
66 name=$1
67 channels=$2
68 bps=$3
69 encode_options="$4"
71 echo -n "$name.bin (--channels=$channels --bps=$bps $encode_options): encode..."
72 cmd="run_flac --verify --silent --force --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --no-padding $name.bin"
73 echo "### ENCODE $name #######################################################" >> ./streams.log
74 echo "### cmd=$cmd" >> ./streams.log
75 $cmd 2>>./streams.log || die "ERROR during encode of $name"
77 echo -n "decode..."
78 cmd="run_flac --silent --force --endian=big --sign=signed --decode --force-raw-format $name.flac";
79 echo "### DECODE $name #######################################################" >> ./streams.log
80 echo "### cmd=$cmd" >> ./streams.log
81 $cmd 2>>./streams.log || die "ERROR during decode of $name"
83 ls -1l $name.bin >> ./streams.log
84 ls -1l $name.flac >> ./streams.log
85 ls -1l $name.raw >> ./streams.log
87 echo -n "compare..."
88 cmp $name.bin $name.raw || die "ERROR during compare of $name"
90 echo OK
93 echo "Testing bins..."
94 for f in b00 b01 b02 b03 b04 ; do
95 binfile=$BINS_PATH/$f
96 if [ -f $binfile.bin ] ; then
97 for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
98 for channels in 1 2 4 8 ; do
99 for bps in 8 16 24 ; do
100 for opt in 0 1 2 4 5 6 8 ; do
101 for extras in '' '-p' '-e' ; do
102 for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
103 test_file $binfile $channels $bps "-$opt $extras $blocksize $disable"
104 done
105 done
106 done
107 if [ "$FLAC__TEST_LEVEL" -gt 1 ] ; then
108 test_file $binfile $channels $bps "--lax -b 16384 -m -r 8 -l 32 -e -p $disable"
110 done
111 done
112 done
113 else
114 echo "$binfile not found, skipping."
116 done